/**
 * 用于微信订单支付
 */
function weiXinPay(data, success, fail) {
	var url = getFullUrl("/api/mobile/wx_pay/pay.do");
	commonWeChatPay(url, success, fail,data);
	return !1;
}

/**
 * 1.用于微信余额充值
 * 2.用于微信发票运费支付
 */
function wechatPay(data, success, fail){
	var url = getFullUrl("/api/mobile/webcat-pay-to/pay.do");
	commonWeChatPay(url, success, fail,data);
	return !1;
}

function commonWeChatPay(url, success, fail,data){	
	var wxPay = api.require('wxPay');
	var options = {
		url : url,
		dataType : "json",
		success : function(data) {
			if (data.result !== 1) {
				e$.alert("程序异常");
				return;
			}
            var timestamp = parseInt(new Date().getTime()/1000);  //订单时间戳
            var payParam = {
                apiKey: data.data['appid'],
                mchId: data.data['mch_id'],
                orderId : data.data['prepay_id'],
                nonceStr : data.data['nonce_str'],
                timeStamp : timestamp,
                package:'Sign=WXPay'
            };
            payParam.sign = $.md5("appid=" + payParam.apiKey
                + '&noncestr=' + payParam.nonceStr
                + '&package=Sign=WXPay'
                + '&partnerid=' + payParam.mchId
                + '&prepayid=' + payParam.orderId
                + '&timestamp=' + timestamp
                + '&key=' + data.data['key']
            );
            wxPay.payOrder(payParam, function(ret2, err) {
                if (ret2.status) {
                    success();
                } else {
                    err.code === -2 ? fail('您已取消支付！') : fail('支付失败，请稍后重试！');
                }
            });
		},
        error: function (e) {
            alert(JSON.stringify(e))
        }
	};
	
	if(data){
		options.data = data;
		options.type = "POST";
	}
	
	e$.ajax(options);
}