/**
 * 
 * Function  : 微信公众号JS-SDK接口接入封装
 * Author    : zqsheng
 * CreateTime: 2017/05/27
 *
 */

;var wxJssdk = {};
wxJssdk.config = function(){
var url = getFullUrl('/api/b2b2c/wechat/jssdk-config.do');
	$.ajax({
		url :url,
		data : {
			"jssdkUrl":location.href.split('#')[0]
		},
		type : "post",
		async : true, 
		cache : false,
		success : function(result) {
			console.log("get jssdk config result",result);
			if(result.result == 1){
				/**
				 * 所有需要使用JS-SDK的页面必须先注入配置信息，同一个url仅需调用一次
				 */
				wx.config({
					debug: false, //开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
					appId: result.data.appid, //必填，公众号的唯一标识
					timestamp: result.data.timestamp, //必填，生成签名的时间戳
					nonceStr: result.data.nonceStr, //必填，生成签名的随机串
					signature: result.data.signature,//必填，签名，见附录1
					jsApiList: [ //必填，需要使用的JS接口列表
						'checkJsApi', //判断当前客户端版本是否支持指定JS接口
						'onMenuShareTimeline',//分享到朋友圈
						'onMenuShareAppMessage',//分享给朋友
						'onMenuShareQQ',//分享到QQ
						'onMenuShareWeibo',//分享到腾讯微博
						'onMenuShareQZone',//分享到QQ空间
						'hideMenuItems',//批量隐藏功能按钮接口
						'showMenuItems',//批量显示功能按钮接口
						'hideAllNonBaseMenuItem',//隐藏所有非基础按钮接口
						'showAllNonBaseMenuItem',//显示所有功能按钮接口
						'translateVoice',//识别音频并返回识别结果接口
						'startRecord',//开始录音接口
						'stopRecord',//停止录音接口
						'onVoiceRecordEnd',//监听录音自动停止
						'playVoice',//播放语音接口
						'onVoicePlayEnd',//监听语音播放完毕接口
						'pauseVoice',//暂停播放接口
						'stopVoice',//停止播放接口
						'uploadVoice',//上传语音接口
						'downloadVoice',//下载语音接口
						'chooseImage',//拍照或从手机相册中选图接口
						'previewImage',//预览图片接口
						'uploadImage',//上传图片接口
						'downloadImage',//下载图片接口
						'getNetworkType',//获取网络状态接口
						'openLocation',//使用微信内置地图查看位置接口
						'getLocation',//获取地理位置接口
						'hideOptionMenu',//隐藏菜单
						'showOptionMenu',//显示菜单
						'closeWindow',//关闭当前网页窗口接口
						'scanQRCode',//调起微信扫一扫接口
						'chooseWXPay',//微信支付
						'openProductSpecificView',//跳转微信商品页
						'addCard',//添加卡券
						'chooseCard',//拉取适用卡券列表并获取用户选择信息
						'openCard'//查看微信卡包中的卡券接口
					]
				}); 
			} else {
				alert(result.message);
			}
		},
		error: function () {
			alert('jssdk注册失败');
        }
	});
};

